/*GMap Class*/

function FM_Map(id,apiCall,mapCenterLat,mapCenterLon,mapType,mapZoom,mapCenterInAddress,mapIconDefault) {

	this.id = null;
	this.apiCall = null;
	
	this.mapCenterLat = 0;
	this.mapCenterLon = 0;
	this.mapZoom = 16;
	this.mapType = "G_DEFAULT_MAP_TYPES";
	//this.mapIconDefault = "framework/img/icon/icon-map-me.png";
	
	this.mapCenterInAddress = null;
	
	this.map = null;
	this.geocoder = null;
	this.markersContent = new Array();
	this.infoWindows = new Array();
	this.infoWindowsOpened = null;
	this.mapLatestLatLongMarker = null;
	
	this.gmapStyles = [
	 {
	    "featureType": "road",
	    "elementType": "labels.text.fill",
	    "stylers": [
	      { "color": "#ffffff" }
	    ]
	  },{
	    "elementType": "labels.text.fill",
	    "stylers": [
	      { "color": "#ffffff" }
	    ]
	  },{
	    "elementType": "labels.text.stroke",
	    "stylers": [
	      { "color": "#334455" }
	    ]
	  },{
	    "featureType": "transit",
	    "elementType": "labels.icon",
	    "stylers": [
	      { "hue": "#0088ff" }
	    ]
	  },{
	    "featureType": "transit.line",
	    "elementType": "geometry",
	    "stylers": [
	      { "color": "#334455" }
	    ]
	  },{
	    "elementType": "geometry.fill",
	    "stylers": [
	      { "color": "#5c85a3" },
	      { "visibility": "on" }
	    ]
	  },{
	    "featureType": "poi",
	    "elementType": "geometry",
	    "stylers": [
	      { "color": "#334455" },
	      { "lightness": 20 }
	    ]
	  },{
	    "featureType": "water",
	    "elementType": "geometry",
	    "stylers": [
	      { "color": "#334455" },
	      { "lightness": 20 }
	    ]
	  },{
	    "featureType": "road",
	    "elementType": "geometry",
	    "stylers": [
	      { "color": "#334455" }
	    ]
	  },{
	  }
	];

    this.create = function (id,apiCall,mapCenterLat,mapCenterLon,mapType,mapZoom,mapCenterInAddress) {
    	if (!_system.isNull(id)) {
    		//console.log("Create map for "+id);
    		//Init class variables
		    if (!_system.isNull(id)) this.id = id;
		    if (!_system.isNull(apiCall)) this.apiCall = apiCall;
		    if (!_system.isNull(mapCenterLat)) this.mapCenterLat = mapCenterLat;
		    if (!_system.isNull(mapCenterLon)) this.mapCenterLon = mapCenterLon;
		    if (!_system.isNull(mapType)) this.mapType = mapType;
		    if (!_system.isNull(mapZoom)) this.mapZoom = mapZoom;
		    if (!_system.isNull(mapCenterInAddress)) this.mapCenterInAddress = mapCenterInAddress;
		    //Create map instance 
		    if (_app.userGeoError == true) {
		    	if (_system.isNull(_searchLatestSearch)) {
		    		_system.currentPosition();
					_system.message("Localizzazione non riuscita. Verifica che il GPS sia attivo oppure utilizza il tasto in alto a destra per indicare la zona di interesse.");			    
		    	}
		    }
	    	if (_system.isNull(this.mapCenterLat)) this.mapCenterLat = _app.userLastLat;
	    	if (_system.isNull(this.mapCenterLon)) this.mapCenterLon = _app.userLastLon;
	    	
			var latlng = new google.maps.LatLng(this.mapCenterLat,this.mapCenterLon );	
			var styles = this.gmapStyles;
			var styledMap = new google.maps.StyledMapType(styles, {name: ""});
	    	var options = { zoom: parseInt(this.mapZoom), center: latlng, mapTypeId: google.maps.MapTypeId.ROADMAP, streetViewControl: false, disableDefaultUI: true,  mapTypeControlOptions: {
			      mapTypeIds: [google.maps.MapTypeId.ROADMAP, 'map_style']
				}};
	    	this.map = new google.maps.Map(document.getElementById(this.id), options);
	    	this.map.mapTypes.set('map_style', styledMap);
			this.map.setMapTypeId('map_style');
			this.geocoder = new google.maps.Geocoder();
			//Set icon center position
			console.log(this.mapIconDefault);
			var myIcon = new google.maps.MarkerImage(this.mapIconDefault, null, null, null, new google.maps.Size(32,32));
			var marker = new google.maps.Marker({ position: latlng, map: this.map, icon: myIcon, animation: google.maps.Animation.DROP});
			//Check API
			if (!_system.isNull(apiCall)) {
				this.callApiMap(apiCall);
			}
    	}
    }
    
    this.callApiMap = function(url) {
    	var _parent = this;
		var filterCall = "";
   		$.getJSON(url, function(data) {
			if (!_system.isNull(data)) {
				_parent.mapLatestLatLongMarker = new google.maps.LatLngBounds();
				for (var i=0; i<data.length; i++) {
					var item = data[i];
					_parent.setMarker(item.lat,item.lon,item.title,"",item.icon,item.action);
				}
				_parent.centerMapAllPoints();
			}
		}).fail(function() {
		
		});
    }
    
    this.centerMapAllPoints = function() {
	    //console.log(this.mapLatestLatLongMarker);
		//this.map.setCenter(bounds.getCenter());
		this.map.fitBounds(this.mapLatestLatLongMarker); 
    }
    
    this.setMarker = function(lat,lon,title,description,icon,action) {

		var i = 0;
		var _parent = this;
		if (_system.isNull(icon)) this.mapIconDefault;
		var content = title;
		//if (!isNull(tblDetail) && !isNull(tblId)) content = "<div class='gmap-icon-detail' onclick=\"parent.gmapOpenPreview('"+tblDetail+"','"+tblId+"')\"><strong>"+title+"</strong></div>";
		var myIcon = new google.maps.MarkerImage(icon, null, null, null, new google.maps.Size(32,32));
  	
	    if (!_system.isNull(lat) && !_system.isNull(lon)) {
	    	var latlng = new google.maps.LatLng(lat,lon);		
			this.mapLatestLatLongMarker.extend(latlng);
							  		
	        var marker = new google.maps.Marker({ map: this.map, icon: myIcon, clickable: true, position: latlng });
	        this.markersContent.push(marker);
	        if (!_system.isNull(title)) {
		        var infoWindow = new google.maps.InfoWindow({ content: "<div class='map-popup-element "+(_system.isNull(action) ? "" : "with-action")+"' action='"+action+"'><div class='map-popup-title'>"+title+"</div><div>"+description+"</div></div>" });
		        this.infoWindows.push(infoWindow);
		        google.maps.event.addListener(marker, 'click', function() {
		        	for (i=0;i<_parent.infoWindows.length;i++) _parent.infoWindows[i].close(); 
		        	if (_parent.infoWindowsOpened!=infoWindow) {		        	
			        	infoWindow.open(this.map,marker); 
						_parent.infoWindowsOpened = infoWindow;
		        	} else {
			        	_parent.infoWindowsOpened = null;
		        	}
		        	//Hide X button
		        	$(".gm-style-iw").next("div").hide();
		        });
		    }
	    }
	}
	    
    if (!_system.isNull(id)) this.id = id;
    if (!_system.isNull(apiCall)) this.apiCall = apiCall;
    if (!_system.isNull(mapCenterLat)) this.mapCenterLat = mapCenterLat;
    if (!_system.isNull(mapCenterLon)) this.mapCenterLon = mapCenterLon;
    if (!_system.isNull(mapType)) this.mapType = mapType;
    if (!_system.isNull(mapZoom)) this.mapZoom = mapZoom;
    if (!_system.isNull(mapCenterInAddress)) this.mapCenterInAddress = mapCenterInAddress;
    
    if (!_system.isNull(mapIconDefault)) {
	    this.mapIconDefault = mapIconDefault;
	} else {
		this.mapIconDefault = "framework/img/icon/icon-map-me.png";
	}
	
    if (!_system.isNull(id)) this.create(id,this.apiCall,this.mapCenterLat,this.mapCenterLon,this.mapType,this.mapZoom,this.mapCenterInAddress);
   
}