/*Toolbar Class*/

var _toolbar = {

	id: "",
	timeToolbarDelay: 350,

    create: function(id) {
    	if (!_system.isNull(id)) this.id = "#"+id;
    	if (!_system.divExist(this.id)) {
	    	$('body').append('<toolbar id="'+id+'"><ul></ul></toolbar>');
	    }
    },
    
    setTopBottom: function(top,bottom) {
    	if (_system.divExist(this.id)) {
	    	if (!_system.isNull(top)) {
	    		$(this.id).css('top',top);
	    	} else {
	    		$(this.id).css('top','auto');		    	
	    	}
	    	if (!_system.isNull(bottom)) {
	    		$(this.id).css('bottom',bottom);
	    	} else {
	    		$(this.id).css('bottom','auto');		    	
	    	}
		}
    },
    
    addHeaderCSS: function(css) {
    	if ($(this.id) && !_system.isNull(css)) {
    		var actualCSS = $(this.id).attr('style');
    		if (!_system.isNull(actualCSS)) actualCSS+=";";
    		actualCSS+=css;
    		$(this.id).attr('style',actualCSS);
	  	}
    },
    
    addButtonDeprecated: function(text,icon,action,viewId,type) {
    	if (_system.divExist(this.id)) {
    		if (_system.isNull(action)) action = "";
    		if (_system.isNull(viewId)) viewId = "";
    		if (_system.isNull(type)) type = "framework";
    		$(this.id+" ul").append('<li view="'+viewId+'" action="'+action+'" index="'+(this.totalButton())+'"><div class="icon" style="background: url('+type+'/img/icon/'+icon+') center center no-repeat; background-size: 28px 28px"></div><div class="text">'+text+'</div></li>');
    		this.buttonAssignWidth();
    	}
    },
    
    addButton: function(text,icon,action,viewId,type) {
    	if (_system.divExist(this.id)) {
    		if (_system.isNull(action)) action = "";
    		if (_system.isNull(viewId)) viewId = "";
    		if (_system.isNull(type)) type = "framework";
    		$(this.id+" ul").append('<li view="'+viewId+'" action="'+action+'" index="'+(this.totalButton())+'"><div class="icon" style="-webkit-mask-image: url('+type+'/img/icon/'+icon+');"></div><div class="text">'+text+'</div></li>');
    		this.buttonAssignWidth();
    	}
    },
    
    removeButton: function(index) {
    	if (_system.divExist(this.id)) {
    		$(this.id+" li:eq("+index+")").remove();
    		this.buttonAssignWidth();
    		var newIndexReassign = 0;
    		$(this.id+" li").each(function() { 
    			$(this).attr('index',newIndexReassign);
	    		newIndexReassign++;
    		});
		}	    	    
    },
    
    removeFirstButton: function() {
	    this.removeButton(0);
    },
    
    removeLastButton: function() {
	    this.removeButton(this.totalButton()-1);
    },
    
    buttonAssignWidth: function() {
    	if (_system.divExist(this.id)) {
		    $(this.id+" li").width((100/this.totalButton())+'%');
		}
    },
    
    selectButton: function(index) {
    	if (_system.divExist(this.id)) {
    		var button = $(this.id+" li:eq("+index+")");
    		$(this.id+" li").removeClass('selected');
    		button.addClass('selected');
    		//Eseguo un refresh dei contenuti dinamici della view
    		var idView = button.attr('view');
    		if (!_system.isNull(idView)) O_Main_View[idView].checkRefreshElements();
		}
    },
    
    selectButtonFromView: function(viewIdSearch) {
    	if (_system.divExist(this.id)) {
    		var indexFound = -1;
    		$(this.id+" li").each(function() {
	    		var viewId = $(this).attr('view');
	    		if (!_system.isNull(viewId)) {
		    		if (viewId==viewIdSearch) {
			    		indexFound = $(this).attr('index');
		    		}
	    		}
    		});
    		if (!_system.isNull(indexFound)) this.selectButton(indexFound);
	    }
    },
    
    totalButton: function() {
	    return $(this.id+" li").length;
    },
    
    show: function () {
    	var toolbarId = this.id;
    	$(toolbarId).show();
    	setTimeout(function() {
	    	$(toolbarId).addClass('show');
    	},10);
    },
    
    hide: function () {
    	var toolbarId = this.id;
	   	$(toolbarId).removeClass('show');
    	setTimeout(function() {
	    	$(toolbarId).hide();
    	},this.timeToolbarDelay);	
    }
   
}