/*View Class*/

function FM_View() {

	this.id = null;
	this.headerbar = null;
	this.totalViewCreated = 0;
	this.timeViewDelay = 410;
	this.history = new Array();
	this.sectionShowed = 0;
	this.sectionMapList = new Array();
	this.sectionCallback = new Array();

    this.create = function(id,content,callback) {	
    	if (!_system.isNull(id)) {
    		this.id = "#"+id;
	    	if (!_system.divExist(id)) {
		    	$('content').append('<view id="'+id+'" index="'+_app.totalViewCreated+'"></view>');
		    	if (_app.totalViewCreated==0) this.historyPush(0);
		    	this.addSection(content,null,callback);
		    	this.showSection();
		    	this.checkIfToolbarExists();
		    }
    		_app.totalViewCreated++;
		    return true;
    	} else {
	    	return false;
    	}
    }
    
    this.addSection = function(content,level,callback) {
	    if (_system.isNull(content)) content = "";
	    if (_system.isNull(level)) level = this.totalSection();
	    if (!_system.isNull(callback)) this.sectionCallback[level] = callback;
	    if (!$(this.id+" .level-"+level).length>0) {
		    $(this.id).append("<section class='level-"+level+" "+(level>0 ? "hide" : "")+"'></section>");	    
	    }
    	if (!_system.isNull(content)) {
    		//Se presente un contenuto in init carico immediatamente
	    	this.html(content,level);
    	}
    }
    
    this.showSection = function(level) {
    	var _this = this;
	    var idView = this.id;
	    var prefixAnimation = "next";
	    if (_system.isNull(level)) level = 0;
	    if (level<this.sectionShowed) prefixAnimation = "back";
	    if (level!=this.sectionShowed) {
	    	this.historyPush(level);
	    	var oldSection = $(idView+" section.level-"+this.sectionShowed)
	   		oldSection.addClass(prefixAnimation+'-slout');
	   		setTimeout(function() {
	   			oldSection.addClass('hide').removeClass(prefixAnimation+'-slout');
	   		},this.timeViewDelay);
	   		this.sectionShowed = level;
	    	if (_system.divExist(idView)) {
	    		var newSection = $(idView+" section.level-"+level);
	    		newSection.removeClass('hide').addClass(prefixAnimation+'-slin');
				setTimeout(function() {
					newSection.removeClass(prefixAnimation+'-slin');
					if (prefixAnimation!="back") _this.checkRefreshElements();
					//Il refresh dell'elemento  richiamato dalla tabbar
		   		},this.timeViewDelay);
		   		if (!_system.isNull(this.sectionCallback[level])) {
			   		eval(this.sectionCallback[level]);
		   		}
	    		this.checkHeaderBackButton();
	    		return true;
			} else {
				return false;
			}
	    }
    }
    
    this.checkRefreshElements = function() {
    	//Verifico la presenza di mappe da refresshare
    	var _parent = this;
    	if (_app.latestViewShowed==this.id) {
	    	$(this.id+" section.level-"+this.sectionShowed+" map").each(function() {
	    		var mapId = $(this).attr('id');
	    		$(this).html('');
		    	if (!_system.isNull(mapId)) {
		    		var apiCall = $(this).attr('apiCall');
		    		var map = $(this);
					setTimeout(function() {
						//Sulla generazione della map  indispensabile ricreare la mappa dopo almeno 50ms per non generare errori grafici di rendering
					    _parent.sectionMapList[mapId] = new FM_Map(mapId,apiCall,map.attr('mapCenterLat'),map.attr('mapCenterLon'),map.attr('mapType'),map.attr('mapZoom'));
					},50);
	    		}		    		
	    	});	    	
    	}
    }
    
    this.showNextSection = function() {
    	var level = this.sectionShowed+1;
    	if ($(this.id+" section.level-"+level).length>0) {
    		this.showSection(level);
    	}
    }
    
    this.nextSection = function() {
	    this.showNextSection();
    }
    
    this.backSection = function() {
		this.historyPop();
    	var level = this.historyLatest();
    	if (level<0 || _system.isNull(level)) level = 0;
    	if ($(this.id+" section.level-"+level).length>0) {
    		this.showSection(level);
    	}
    }
    
    this.prevSection = function() {
	    this.backSection();
    }
    
    this.checkHeaderBackButton = function() {
    	if (!_system.isNull(this.headerbar)) {
		    if (this.sectionShowed==0) {
			    this.headerbar.removeButtonBack();
		    } else {
			    this.headerbar.addButtonBack();
		    }
    	}
    }
    
    this.totalSection = function() {
	    return $(this.id+" section").length;
    }
    
    this.append = function(content,level) {
	    if (_system.isNull(level)) level = 0;
    	if (_system.divExist(this.id)) {
    		$(this.id+" section.level-"+level).append(content);
    		return true;
		} else {
			return false;
		}
    }
    
    this.html = function(content,level) {
	    if (_system.isNull(level)) level = 0;
    	if (_system.divExist(this.id)) {
    		$(this.id+" section.level-"+level).html(content);
    		return true;
		} else {
			return false;
		}
    }
    
    this.cancel = function() {
    	if (_system.divExist(this.id)) {
    		$(this.id).html('');
    		return true;
		} else {
			return false;
		}
    }
    
    this.viewCheckHeaderButtonBack = function() {
    	if (this.history.length>1) {
    		_app.headerbar.addButtonBack();
    	} else {
    		_app.headerbar.removeButtonBack();	    	
    	}	    
    }
    
    this.viewCheckToolbarButtonSelect = function() {
    	_app.toolbar.selectButtonFromView(this.id.replace("#",""));	    
    }
    
    this.headerCreate = function(title) {
	    //Genero nuova headerbar in questa view
	    
	    this.headerbar = new FM_Headerbar();
	    this.headerbar.create(this.id.replace('#',''),title);
	    this.headerbar.show();
	    
		$(this.id).addClass('with-header');
    }
    
    this.checkIfToolbarExists = function() {
	    if (!_system.isNull(_app.toolbar)) {
			$(this.id).addClass('with-toolbar');		    
	    }
    }
    
    this.historyPush = function(level) {
		this.history.push(level);
    }

    this.historyPop = function() {
		this.history.pop();
    }
    
    this.historyLatest = function() {
	  	return this.history[this.history.length-1];  
    }
    
    this.historyReset = function() {
	    this.history = new Array();
    }
    
    this.show = function () {
    	if (_app.latestViewShowed!=this.id) {
        	var viewId = this.id;
        	console.log("Show view: "+viewId);
	    	this.hideLatestView();
	    	_app.latestViewShowed = this.id;
	    	//Controllo header back button
	    	//this.viewCheckHeaderButtonBack();
	    	//Controllo toolbar select button
	    	this.viewCheckToolbarButtonSelect();
	    	//Visualizzazione della view
	    	$(viewId).show();
	    	setTimeout(function() {
		    	$(viewId).addClass('show');
	    	},10);	
	    	if (!_system.isNull(gaPlugin)) gaPlugin.trackPage( function() {}, function() {}, viewId);
			//if (!_system.isNull(_analytics)) _analytics.trackPage( function() {}, function() {}, viewId);
			//_analytics.sendAppView(viewId, function() {}, function() {console.log("Error GA send page!");});
    	}
    }
    
    this.hide = function () {
    	var viewId = this.id;
	   	$(viewId).removeClass('show');
    	setTimeout(function() {
	    	$(viewId).hide();
    	},this.timeViewDelay);	
    }
    
    this.hideLatestView = function() {
	    if (!_system.isNull(_app.latestViewShowed)) {
		    var viewId = _app.latestViewShowed
			$(viewId).removeClass('show');
	    	setTimeout(function() {
		    	$(viewId).hide();
	    	},this.timeViewDelay);	
	    }
    }
    
}